SystemOrganization addCategory: #Calendario!
SystemOrganization addCategory: #'Calendario-Tests'!

TestCase subclass: #DiaMesAnioDAnioHTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario-Tests'!

!DiaMesAnioDAnioHTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 11/6/2012 16:40'!
testCalendarioFeriadoDesdeHasta06
	|fecha1 unFeriadoDH fecha2 fecha3|
	fecha1:= Date year:1981 month:9 day:25.
	fecha2 :=Date year:1984 month:9 day:25.
	fecha3 :=Date year:1990 month:9 day:25.
	unFeriadoDH:= DiaMesAnioDAnioH dia: 25 mes: 9 anioDesde: 1982 anioHasta: 1989.
	self deny: (unFeriadoDH esFeriadoEnRango: fecha1).
	self deny: (unFeriadoDH esFeriadoEnRango: fecha3).
	self assert: (unFeriadoDH esFeriadoEnRango: fecha2).
	! !

TestCase subclass: #DiaMesAnioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario-Tests'!

TestCase subclass: #DiaSemanaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario-Tests'!

!DiaSemanaTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 11/6/2012 14:35'!
testDiaSemana
	|fecha1 unaSemana fecha2|
	fecha1:= Date year:2012 month:10 day:8.
	fecha2:= Date year:2012 month:11 day:12.
	unaSemana := DiaSemana dia: 2 semana: 2.
	self assert:(unaSemana coincideConFecha: fecha1).
	self assert:(unaSemana coincideConFecha: fecha2)
! !

TestCase subclass: #DiaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario-Tests'!

!DiaTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/30/2012 19:32'!
testDiasSonLaborables01
	|dia|
	dia:=Lunes new.
	self assert: (dia esLaborable).
	dia:=Martes new.
	self assert: (dia esLaborable).
	dia:=Miercoles new.
	self assert: (dia esLaborable).
	dia:=Jueves new.
	self assert: (dia esLaborable).
	dia:=Viernes new.
	self assert: (dia esLaborable).
	dia:=Sabado new.
	self deny: (dia esLaborable).
	dia:=Domingo new.
	self deny: (dia esLaborable).! !

TestCase subclass: #UnCalendarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario-Tests'!

!UnCalendarioTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/30/2012 19:58'!
testCalendarioDiaDomingoEsLaborable01
	|un28oct2012 unCalendario|
	un28oct2012:= Date year:2012 month:10 day:28.
	unCalendario := UnCalendario new.
	self deny: (unCalendario esLaborable: un28oct2012).! !

!UnCalendarioTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/30/2012 19:58'!
testCalendarioDiaLunesEsLaborable02
	|un29oct2012 unCalendario|
	un29oct2012:= Date year:2012 month:10 day:29.
	unCalendario := UnCalendario new.
	self assert:  (unCalendario esLaborable: un29oct2012).! !

!UnCalendarioTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/30/2012 21:24'!
testCalendarioEspecificoEsLaborable03
	|navidad unCalendario otroDia|
	navidad:= Date year:1981 month:9 day:25.
	otroDia :=Date year:1984 month:9 day:25.
	unCalendario := UnCalendario new.
	unCalendario fijarFeriadoEnDia: 25 mes: 9 anio:1981.
	self deny: (unCalendario esLaborable: navidad).
	self assert: (unCalendario esLaborable: otroDia )! !

!UnCalendarioTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 11/6/2012 15:18'!
testCalendarioFeriadoDesdeHasta06
	|fecha1 unCalendario fecha2 fecha3|
	fecha1:= Date year:1981 month:9 day:25.
	fecha2 :=Date year:1984 month:9 day:25.
	fecha3 :=Date year:1990 month:9 day:25.
	unCalendario := UnCalendario new.
	unCalendario fijarFeriadoEnDia: 25 mes: 9 anioDesde:1982 anioHasta: 1989.
	self deny: (unCalendario esLaborable: fecha2).
	self assert: (unCalendario esLaborable: fecha1 ).
	self assert: (unCalendario esLaborable: fecha3 ).! !

!UnCalendarioTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 11/6/2012 14:58'!
testCalendarioFeriadoDiaSemana05
	|fecha1 unCalendario fecha2|
	fecha1:= Date year:2012 month:10 day:8.
	fecha2:= Date year:2012 month:11 day:12.
	unCalendario := UnCalendario new.
	unCalendario fijarFeriadoEnDia: 2 semana: 2.
	self deny: (unCalendario esLaborable: fecha1).
	self deny: (unCalendario esLaborable: fecha2).! !

!UnCalendarioTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 11/6/2012 13:52'!
testCalendarioFeriadoTrasladableEsLaborable04
	|fecha1 unCalendario fecha2|
	fecha1:= Date year:2012 month:10 day:22.
	fecha2:= Date year:2012 month:10 day:25.
	unCalendario := UnCalendario new.
	unCalendario fijarFeriadoTrasladableEnDia: 25 mes: 10.
	self deny: (unCalendario esLaborable: fecha1).
	self assert: (unCalendario esLaborable: fecha2).! !

!UnCalendarioTest methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/30/2012 21:23'!
testCalendarioNavidadEsLaborable02
	|navidad unCalendario|
	navidad:= Date year:2012 month:12 day:25.
	unCalendario := UnCalendario new.
	unCalendario fijarFeriadoEnDia: 25 mes: 12.
	self deny: (unCalendario esLaborable: navidad).! !

Object subclass: #Dia
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

Dia subclass: #Domingo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!Domingo methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/30/2012 19:42'!
esLaborable
	^false! !

Dia subclass: #Jueves
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!Jueves methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 19:38'!
esLaborable
	^true.! !

Dia subclass: #Lunes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!Lunes methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 19:37'!
esLaborable
	^true! !

Dia subclass: #Martes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!Martes methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 19:38'!
esLaborable
	^true.! !

Dia subclass: #Miercoles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!Miercoles methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 19:38'!
esLaborable
	^true.! !

Dia subclass: #Sabado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!Sabado methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 19:42'!
esLaborable
	^false! !

Dia subclass: #Viernes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!Viernes methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 19:39'!
esLaborable
	^true.! !

Object subclass: #DiaMes
	instanceVariableNames: 'dia mes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!DiaMes class methodsFor: 'instance creation' stamp: 'MartnPerazzo 10/30/2012 20:25'!
dia: unDia mes: unMes
	^self new initializeConDia: unDia mes: unMes.! !

!DiaMes methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/30/2012 20:57'!
= anObject
	^((self class=anObject class)&(dia=anObject dia)&(mes=anObject mes)).! !

!DiaMes methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 20:33'!
dia
	^ dia! !

!DiaMes methodsFor: 'private' stamp: 'MartnPerazzo 10/30/2012 20:27'!
initializeConDia: unDia mes: unMes
	dia:=unDia.
	mes:=unMes.! !

!DiaMes methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 20:33'!
mes
	^ mes! !

!DiaMes methodsFor: 'evaluating' stamp: 'MartnPerazzo 11/6/2012 13:50'!
subtractDate: aDate 
	|DiaEnAnio diferencia|
	DiaEnAnio := Date year: (aDate year) month: mes  day: dia.
	diferencia := DiaEnAnio subtractDate: aDate.
	^(diferencia).! !

Object subclass: #DiaMesAnio
	instanceVariableNames: 'dia mes anio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!DiaMesAnio class methodsFor: 'instance creation' stamp: 'MartnPerazzo 10/30/2012 21:07'!
dia: unDia mes: unMes anio: unAnio 
	^self new initializeConDia: unDia mes: unMes anio: unAnio.! !

!DiaMesAnio methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/30/2012 20:59'!
= anObject
	^((self class=anObject class)&(dia=anObject dia)&(mes=anObject mes)&(anio=anObject anio)).! !

!DiaMesAnio methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 21:11'!
anio
	^ anio! !

!DiaMesAnio methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 21:10'!
dia
	^ dia! !

!DiaMesAnio methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 10/30/2012 20:58'!
initializeConDia: unDia mes: unMes anio: unAnio
	dia:=unDia.
	mes:=unMes.
	anio:=unAnio! !

!DiaMesAnio methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 21:11'!
mes
	^ mes! !

Object subclass: #DiaMesAnioDAnioH
	instanceVariableNames: 'dia mes anioDesde anioHasta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!DiaMesAnioDAnioH class methodsFor: 'instance creation' stamp: 'MartnPerazzo 11/6/2012 15:20'!
dia: unDia mes: unMes  anioDesde: unAnioDesde anioHasta: unAnioHasta 
	^(self new initializeCondia: unDia mes: unMes  anioDesde: unAnioDesde anioHasta: unAnioHasta).! !

!DiaMesAnioDAnioH methodsFor: 'evaluating' stamp: 'MartnPerazzo 11/6/2012 16:44'!
esFeriadoEnRango: aDate
	^((aDate year >= anioDesde ) & (aDate year <= anioHasta ) & (aDate monthIndex  = mes) &(aDate dayOfMonth = dia)).! !

!DiaMesAnioDAnioH methodsFor: 'updating' stamp: 'MartnPerazzo 11/6/2012 15:22'!
initializeCondia: unDia mes: unMes  anioDesde: unAnioDesde anioHasta: unAnioHasta 
	dia:=unDia.
	mes:=unMes.
	anioDesde := unAnioDesde.
	anioHasta := unAnioHasta .! !

Object subclass: #DiaSemana
	instanceVariableNames: 'dia semana'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!DiaSemana class methodsFor: 'instance creation' stamp: 'MartnPerazzo 11/6/2012 14:16'!
dia: unDia semana: unaSemana 
	^(self new initializeConDia: unDia  semana: unaSemana).! !

!DiaSemana methodsFor: 'evaluating' stamp: 'MartnPerazzo 11/6/2012 14:58'!
coincideConFecha: aDate 
	| unDia unaSemana unaFecha|
	unDia:=aDate weekdayIndex.
	unaSemana:=aDate asWeek index.
	unaFecha := aDate subtractDays: (aDate dayOfMonth - 1).
	unDia < (unaFecha weekdayIndex  )
	ifTrue: [ unaSemana:=unaSemana -1 ].
	^((dia = unDia) & (unaSemana = semana)).! !

!DiaSemana methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 11/6/2012 14:05'!
dia
	^dia! !

!DiaSemana methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 11/6/2012 14:14'!
initializeConDia: unDia semana: unSemana
	dia:=unDia.
	semana :=unSemana .! !

!DiaSemana methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 11/6/2012 14:05'!
semana
	^semana! !

Object subclass: #UnCalendario
	instanceVariableNames: 'feriados feriadosEpecificos feriadosTrasladables feriadosDiaSemana feriadosDesdeHasta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Calendario'!

!UnCalendario methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 20:38'!
esDiaDeSemana: aDate 
	^((aDate weekdayIndex > 1) & (aDate weekdayIndex < 7)).! !

!UnCalendario methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 21:15'!
esFeriado: aDate 
	^(feriados includes: (DiaMes  dia:(aDate dayOfMonth ) mes: (aDate monthIndex  )))! !

!UnCalendario methodsFor: 'evaluating' stamp: 'MartnPerazzo 11/6/2012 20:06'!
esFeriadoDesdeHasta: aDate 
	^(feriadosDesdeHasta anySatisfy:  [ :unRango | unRango esFeriadoEnRango: aDate ])! !

!UnCalendario methodsFor: 'evaluating' stamp: 'MartnPerazzo 11/6/2012 20:06'!
esFeriadoDiaSemana: aDate 
	^(feriadosDiaSemana anySatisfy:  [:diaSemana | diaSemana coincideConFecha: aDate ])! !

!UnCalendario methodsFor: 'evaluating' stamp: 'MartnPerazzo 10/30/2012 21:22'!
esFeriadoEspecifico: aDate 
	^(feriadosEpecificos  includes: (DiaMesAnio  dia:(aDate dayOfMonth ) mes: (aDate monthIndex  ) anio: (aDate year) ))! !

!UnCalendario methodsFor: 'evaluating' stamp: 'MartnPerazzo 11/6/2012 20:06'!
esFeriadoTrasladable: aDate 
	^(((aDate weekdayIndex) = 2) & (feriadosTrasladables anySatisfy:  [ :unDia | ((unDia subtractDate: aDate) > -1) & ((unDia subtractDate: aDate) < 7) ])).! !

!UnCalendario methodsFor: 'evaluating' stamp: 'MartnPerazzo 11/6/2012 15:13'!
esLaborable: aDate 
	^(((self esFeriado: aDate) not)&((self esFeriadoEspecifico: aDate) not)&((self esFeriadoTrasladable: aDate) not)&(self esDiaDeSemana: aDate)&((self esFeriadoDiaSemana: aDate) not)&((self esFeriadoDesdeHasta: aDate) not))! !

!UnCalendario methodsFor: 'updating' stamp: 'MartnPerazzo 10/30/2012 20:55'!
fijarFeriadoEnDia: unDia mes: unMes
	feriados add: (DiaMes dia: unDia mes: unMes).! !

!UnCalendario methodsFor: 'updating' stamp: 'MartnPerazzo 10/30/2012 21:16'!
fijarFeriadoEnDia: unDia mes: unMes anio: unAnio 
	feriadosEpecificos  add: (DiaMesAnio dia: unDia mes: unMes anio: unAnio).! !

!UnCalendario methodsFor: 'updating' stamp: 'MartnPerazzo 11/6/2012 15:18'!
fijarFeriadoEnDia: unDia  mes: unMes  anioDesde: unAnioDesde anioHasta: unAnioHasta 
	feriadosDesdeHasta add: (DiaMesAnioDAnioH dia: unDia  mes: unMes  anioDesde: unAnioDesde anioHasta: unAnioHasta)! !

!UnCalendario methodsFor: 'updating' stamp: 'MartnPerazzo 11/6/2012 14:13'!
fijarFeriadoEnDia: unDia semana: unaSemana 
	feriadosDiaSemana add: (DiaSemana dia: unDia semana: unaSemana).! !

!UnCalendario methodsFor: 'updating' stamp: 'MartnPerazzo 10/30/2012 21:28'!
fijarFeriadoTrasladableEnDia: unDia mes: unMes
	feriadosTrasladables add: (DiaMes dia: unDia mes: unMes).! !

!UnCalendario methodsFor: 'as yet unclassified' stamp: 'MartnPerazzo 11/6/2012 15:17'!
initialize
	feriados:= OrderedCollection new.
	feriadosEpecificos := OrderedCollection new.
	feriadosTrasladables := OrderedCollection new.
	feriadosDiaSemana := OrderedCollection new.
	feriadosDesdeHasta := OrderedCollection new.! !
